GDAL: GDALWarpOptions Struct Reference

# GDALWarpOptions Struct Reference

`#include <gdalwarper.h>`

List of all members.

## Public Attributes
char ** | papszWarpOptions
double | dfWarpMemoryLimit
GDALResampleAlg | eResampleAlg
GDALDataType | eWorkingDataType
GDALDatasetH | hSrcDS
GDALDatasetH | hDstDS
int | nBandCount
int * | panSrcBands
int * | panDstBands
int | nSrcAlphaBand
int | nDstAlphaBand
double * | padfSrcNoDataReal
double * | padfSrcNoDataImag
double * | padfDstNoDataReal
double * | padfDstNoDataImag
GDALProgressFunc | pfnProgress
void * | pProgressArg
GDALTransformerFunc | pfnTransformer
void * | pTransformerArg
GDALMaskFunc * | papfnSrcPerBandValidityMaskFunc
void ** | papSrcPerBandValidityMaskFuncArg
GDALMaskFunc | pfnSrcValidityMaskFunc
void * | pSrcValidityMaskFuncArg
GDALMaskFunc | pfnSrcDensityMaskFunc
void * | pSrcDensityMaskFuncArg
GDALMaskFunc | pfnDstDensityMaskFunc
void * | pDstDensityMaskFuncArg
GDALMaskFunc | pfnDstValidityMaskFunc
void * | pDstValidityMaskFuncArg
CPLErr(* | pfnPreWarpChunkProcessor )(void *pKern, void *pArg)
void * | pPreWarpProcessorArg
CPLErr(* | pfnPostWarpChunkProcessor )(void *pKern, void *pArg)
void * | pPostWarpProcessorArg
void * | hCutline
double | dfCutlineBlendDist

## Detailed Description

Warp control options for use with GDALWarpOperation::Initialize()

## Member Data Documentation

double GDALWarpOptions::dfWarpMemoryLimit

In bytes, 0.0 for internal default

Referenced by GDALWarpOperation::Initialize().

GDALResampleAlg GDALWarpOptions::eResampleAlg

Resampling algorithm to use

Referenced by GDALAutoCreateWarpedVRT(), GDALReprojectImage(), and GDALWarpOperation::WarpRegionToBuffer().

GDALDataType GDALWarpOptions::eWorkingDataType

data type to use during warp operation, GDT_Unknown lets the algorithm select the type

Referenced by GDALWarpOperation::Initialize(), GDALWarpOperation::WarpRegion(), and GDALWarpOperation::WarpRegionToBuffer().

GDALDatasetH GDALWarpOptions::hDstDS

Destination image dataset - may be NULL if only using GDALWarpOperation::WarpRegionToBuffer().

Referenced by GDALCreateWarpedVRT(), GDALReprojectImage(), GDALWarpOperation::Initialize(), and GDALWarpOperation::WarpRegion().

GDALDatasetH GDALWarpOptions::hSrcDS

Source image dataset.

Referenced by GDALAutoCreateWarpedVRT(), GDALReprojectImage(), GDALWarpOperation::Initialize(), and GDALWarpOperation::WarpRegionToBuffer().

int GDALWarpOptions::nBandCount

Number of bands to process, may be 0 to select all bands.

Referenced by GDALAutoCreateWarpedVRT(), GDALCreateWarpedVRT(), GDALReprojectImage(), GDALWarpOperation::Initialize(), GDALWarpOperation::WarpRegion(), and GDALWarpOperation::WarpRegionToBuffer().

int GDALWarpOptions::nDstAlphaBand

The dest. band so use as an alpha (transparency) value, 0=disabled

Referenced by GDALWarpOperation::WarpRegionToBuffer().

int GDALWarpOptions::nSrcAlphaBand

The source band so use as an alpha (transparency) value, 0=disabled

Referenced by GDALWarpOperation::WarpRegionToBuffer().

double* GDALWarpOptions::padfDstNoDataImag

The "nodata" value imaginary component - may be NULL even if real component is provided.

Referenced by GDALWarpOperation::WarpRegion(), and GDALWarpOperation::WarpRegionToBuffer().

double* GDALWarpOptions::padfDstNoDataReal

The "nodata" value real component for each output band, if NULL there isn't one

Referenced by GDALWarpOperation::WarpRegion(), and GDALWarpOperation::WarpRegionToBuffer().

double* GDALWarpOptions::padfSrcNoDataImag

The "nodata" value imaginary component - may be NULL even if real component is provided.

Referenced by GDALReprojectImage(), GDALWarpOperation::Initialize(), and GDALWarpOperation::WarpRegionToBuffer().

double* GDALWarpOptions::padfSrcNoDataReal

The "nodata" value real component for each input band, if NULL there isn't one

Referenced by GDALReprojectImage(), GDALWarpOperation::Initialize(), and GDALWarpOperation::WarpRegionToBuffer().

int* GDALWarpOptions::panDstBands

The band numbers for the destination bands to process (1 based)

Referenced by GDALAutoCreateWarpedVRT(), GDALReprojectImage(), GDALWarpOperation::Initialize(), and GDALWarpOperation::WarpRegion().

int* GDALWarpOptions::panSrcBands

The band numbers for the source bands to process (1 based)

Referenced by GDALAutoCreateWarpedVRT(), GDALReprojectImage(), GDALWarpOperation::Initialize(), and GDALWarpOperation::WarpRegionToBuffer().

char ** GDALWarpOptions::papszWarpOptions

A string list of additional options controlling the warp operation in name=value format. A suitable string list can be prepared with CSLSetNameValue().

The following values are currently supported:

- INIT_DEST=[value] or INIT_DEST=NO_DATA: This option forces the destination image to be initialized to the indicated value (for all bands) or indicates that it should be initialized to the NO_DATA value in padfDstNoDataReal/padfDstNoDataImag. If this value isn't set the destination image will be read and overlayed.

- WRITE_FLUSH=YES/NO: This option forces a flush to disk of data after each chunk is processed. In some cases this helps ensure a serial writing of the output data otherwise a block of data may be written to disk each time a block of data is read for the input buffer resulting in alot of extra seeking around the disk, and reduced IO throughput. The default at this time is NO.

- SKIP_NOSOURCE=YES/NO: Skip all processing for chunks for which there is no corresponding input data. This will disable initializing the destination (INIT_DEST) and all other processing, and so should be used careful. Mostly useful to short circuit a lot of extra work in mosaicing situations.

Normally when computing the source raster data to load to generate a particular output area, the warper samples transforms 21 points along each edge of the destination region back onto the source file, and uses this to compute a bounding window on the source image that is sufficient. Depending on the transformation in effect, the source window may be a bit too small, or even missing large areas. Problem situations are those where the transformation is very non-linear or "inside out". Examples are transforming from WGS84 to Polar Steregraphic for areas around the pole, or transformations where some of the image is untransformable. The following options provide some additional control to deal with errors in computing the source window:

- SAMPLE_GRID=YES/NO: Setting this option to YES will force the sampling to include internal points as well as edge points which can be important if the transformation is esoteric inside out, or if large sections of the destination image are not transformable into the source coordinate system.

- SAMPLE_STEPS: Modifies the density of the sampling grid. The default number of steps is 21. Increasing this can increase the computational cost, but improves the accuracy with which the source region is computed.

- SOURCE_EXTRA: This is a number of extra pixels added around the source window for a given request, and by default it is 1 to take care of rounding error. Setting this larger will incease the amount of data that needs to be read, but can avoid missing source data.

Referenced by GDALWarpOperation::Initialize(), GDALWarpOperation::WarpRegion(), and GDALWarpOperation::WarpRegionToBuffer().

GDALProgressFunc GDALWarpOptions::pfnProgress

GDALProgressFunc() compatible progress reporting function, or NULL if there isn't one.

Referenced by GDALWarpOperation::ChunkAndWarpImage(), GDALReprojectImage(), and GDALWarpOperation::WarpRegionToBuffer().

GDALTransformerFunc GDALWarpOptions::pfnTransformer

Type of spatial point transformer function

Referenced by GDALAutoCreateWarpedVRT(), GDALReprojectImage(), and GDALWarpOperation::WarpRegionToBuffer().

void* GDALWarpOptions::pProgressArg

Callback argument to be passed to pfnProgress.

Referenced by GDALWarpOperation::ChunkAndWarpImage(), GDALReprojectImage(), and GDALWarpOperation::WarpRegionToBuffer().

void* GDALWarpOptions::pTransformerArg

Handle to image transformer setup structure

Referenced by GDALAutoCreateWarpedVRT(), GDALReprojectImage(), and GDALWarpOperation::WarpRegionToBuffer().

The documentation for this struct was generated from the following files:

- gdalwarper.h
- gdalwarper.cpp

Generated for GDAL by 1.5.9.